 /*
  * Mike's Raycaster 0.5 - A demonstration of raycasting in java
  * 	http://mike.bitrevision.com/raycaster/
  * 
  * Copyright (c) 2008-2012 Michael Billington <michael.billington@gmail.com>
  * 
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:

  * The above copyright notice and this permission notice shall be included in
  * all copies or substantial portions of the Software.

  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE. */

import java.awt.*;

public class DisplayCanvas extends Canvas {
	/**
	 * Canvas used for rendering
	 */
	private static final long serialVersionUID = 1L;
	Graphics buffer;
	Image bufferImg = null;
	Dimension d;
	boolean hasBuffer = false;	

	public DisplayCanvas() {
		
	}

	public void remakeBuffer() {
		d = getSize();
		// System.out.println("Canvas is " + d.width + " wide, " + d.height + " tall.");
		bufferImg = createImage(d.width, d.height);
		buffer = bufferImg.getGraphics();
	}

	public void update(Graphics graphics) {
		Dimension dNew = getSize();

		if(!hasBuffer || (dNew.width != d.width || dNew.height != d.height)) {
			/* Regenerate image buffer if window has been resized lately */
			remakeBuffer();
			hasBuffer = true;
		}
		
		/* Clear area, and ask engine to write here */
		Engine.renderFrame(buffer, d);
		
		/* Copy to this place */
		graphics.drawImage(bufferImg, 0, 0, this);
	}
}
