 /*
  * Mike's Raycaster 0.5 - A demonstration of raycasting in java
  * 	http://mike.bitrevision.com/raycaster/
  * 
  * Copyright (c) 2008-2012 Michael Billington <michael.billington@gmail.com>
  * 
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:

  * The above copyright notice and this permission notice shall be included in
  * all copies or substantial portions of the Software.

  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
  * THE SOFTWARE. */

class PlayerPos {
	/* Describes the position of the player at a given time */
	public int BlockX = 0;
	public int BlockY = 0;
	public int PosX = 0;
	public int PosY = 0;
	public double angle;

	public PlayerPos(double curAngle, int curBlockX, int curBlockY, int curPosX, int curPosY) {
		BlockX = curBlockX;
		PosX = curPosX;
		PosY = curPosY;
		BlockY = curBlockY;
		angle = curAngle;
	}

	public PlayerPos(double curAngle, double curX, double curY) {
		angle = curAngle;
		BlockX	= (int)curX / Raycaster.BLOCK_SIZE;
		BlockY	= (int)curY / Raycaster.BLOCK_SIZE;
		PosX	= (int)curX % Raycaster.BLOCK_SIZE;
		PosY	= (int)curY % Raycaster.BLOCK_SIZE;
	}
}
